# Battery charging

A decision block that checks if battery is charging or discharging.

If the proceed option is set to Immediately, then check the battery is considered charging without pausing the fiber. If set to When changed, then the fiber will pause until the battery begins charging or discharging.

If this block don’t work as expect then the Battery level and Power source plugged blocks could be used as alternatives.

Note! On some devices the “charging” state as reported by this block may be delayed, temporarily incorrect, or not work at all.

## Options

- Proceed — when the fiber should proceed.

## Output variables

- Time until fully charged — variable to assign the approximate time until the battery is fully charged in seconds, or `null` if discharging or unable to estimate. (Android 9+)